import commands
import glob
import os
import shutil
import sys

directory = sys.argv[1]
files = glob.glob("%s/*.pcap" % (directory))
for file in files:
	rv = commands.getstatusoutput("tcpdump -n -r %s ip > %s.txt" % (file, file))
	rv = commands.getstatusoutput("python normalize.py %s.txt %s.norm" % (file, file))
	if rv[0] != 0:
		print rv
		print "Problem with file %s, aborting" % (file)
		sys.exit(1)
	rv = commands.getstatusoutput('grep "client > server" %s.norm > %s.client' % (file, file))
	rv = commands.getstatusoutput('grep "server > client" %s.norm > %s.server' % (file, file))

files = glob.glob("%s/*.loss" % (directory))
basenames = []
for file in files:
	file = file.split(".loss")[0]
	basenames.append(file)

for file in basenames:
	def diff_file(a, b, c):
		cmd = "diff -U 1000 %s %s > %s" % (a, b, c)
		rv = commands.getstatusoutput(cmd)
		if rv[0] == 0:
			# No diffs
			shutil.copy(a, c)
	def process_diff(a, b):
		lines = open(a).readlines()
		newlines = []
		for line in lines:
			if line.startswith("---") or line.startswith("+++") or line.startswith("@@"):
				continue
			line = line.strip()
			if line.startswith("-") or line.startswith("+"):
				line = line[1:] + " dropped"
			line = line.strip() + "\n"
			newlines.append(line)
		outfile = open(b, "w")
		outfile.writelines(newlines)
	file1 = "%s%%le1.pcap" % (file)
	file2 = "%s%%le2.pcap" % (file)
	diff_file(file1 + ".client", file2 + ".client", file + ".client.preprocessed")
	diff_file(file1 + ".server", file2 + ".server", file + ".server.preprocessed")
	process_diff(file + ".client.preprocessed", file + ".client.processed")
	process_diff(file + ".server.preprocessed", file + ".server.processed")

