# This program runs the tests to gather tcpdump data
# for analysis by tcpdiff

import commands
import os
import sys
import time

if len(sys.argv) != 2:
	print "Please provide a system to test"
	sys.exit(1)

settings = eval(open("testhosts").read())

dut_name = sys.argv[1]
dut = settings.get(dut_name)

if not dut:
	print "System to test not found"
	sys.exit(1)

cmd = "ls /boot | grep testkernel"
rv = commands.getstatusoutput("ssh root@%s %s" % (dut['mgmt_ip'], cmd))
kernels = rv[1].splitlines()

for kernel in kernels:
	print "Setting up for test of kernel %s" % (kernel)
	cmd = "rm /boot/kernel"
	rv = commands.getstatusoutput("ssh root@%s %s" % (dut['mgmt_ip'], cmd))
	cmd = "ln -s /boot/%s /boot/kernel" % (kernel)
	rv = commands.getstatusoutput("ssh root@%s %s" % (dut['mgmt_ip'], cmd))
	cmd = "shutdown -r now"
	rv = commands.getstatusoutput("ssh root@%s %s" % (dut['mgmt_ip'], cmd))
	print "Sleeping before start of test %s" % (kernel)
	time.sleep(60)
	print "Running test 1 of %s" % (kernel)
	cmd = "python runtests.py freebsd7"
	rv = commands.getstatusoutput(cmd)
	time.sleep(15)
	print "Running test 2 of %s" % (kernel)
	cmd = "python runtests.py freebsd7"
	rv = commands.getstatusoutput(cmd)
	time.sleep(15)
	print "Running test 3 of %s" % (kernel)
	cmd = "python runtests.py freebsd7"
	rv = commands.getstatusoutput(cmd)
print "All kernels tested"
